//+------------------------------------------------------------------+
//|                                                Cronex Taichi.mq4 |
//|                                                                  |
//| original indicator developed by cronex                           |
//| improvments and cleanup made by newdigital and mladen            |
//+------------------------------------------------------------------+
#property  copyright "www.forex-tsd.com"
#property  link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_color3  Lime
#property  indicator_color4  Orange
#property  indicator_color5  DeepSkyBlue
#property  indicator_width1  2
#property  indicator_minimum 0
#property  indicator_maximum 2

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    Tenkan      =  9;
extern int    Kijun       = 26;
extern int    Senkou      = 52;
extern bool   Interpolate = true;

//
//
//
//
//

double     TaichiUp[];
double     TaichiDn[];
double     SignalUp[];
double     SignalDn[];
double     FlatBuffer[];
double     wTaichiBuffer[];
double     wTaichiForBuffer[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorDigits(Digits+1);
   IndicatorBuffers(7);
      SetIndexBuffer(0,FlatBuffer);   SetIndexLabel(0,"Flat");       SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,SignalDn);     SetIndexLabel(1,"SignalDown"); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,SignalUp);     SetIndexLabel(2,"SignalUp");   SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,TaichiDn);     SetIndexLabel(3,"TaichiDown"); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,TaichiUp);     SetIndexLabel(4,"TaichiUp");   SetIndexStyle(4,DRAW_HISTOGRAM);
      SetIndexBuffer(5,wTaichiBuffer);    
      SetIndexBuffer(6,wTaichiForBuffer); 

   //
   //
   //
   //
   //
   
      indicatorFileName = WindowExpertName();
      timeFrame         = stringToTimeFrame(TimeFrame);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);

   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(timeFrame)+" Cronex Taichi");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { FlatBuffer[0] = MathMin(limit+Kijun,Bars-1); return(0); }

   //
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(i=-Kijun; i<limit; i++)
      {
         double TenkanSen   = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_TENKANSEN,i);
         double KijunSen    = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_KIJUNSEN,i);
         double SenkouSpanA = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANA,i);
         double SenkouSpanB = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANB,i);
         double ChinkouSpan = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_CHINKOUSPAN,i);      

         wTaichiForBuffer[i+Kijun] = (SenkouSpanA+SenkouSpanB)/2.0;
         if (i>=0)
               wTaichiBuffer[i] = (TenkanSen+KijunSen+SenkouSpanA+SenkouSpanB)/4.0;
      }

      //
      //
      //
      //
      //
      
      for(i=limit; i>=0; i--)
      {
         double Signal  = iLwma(wTaichiBuffer,Kijun ,i);
         double SSignal = iLwma(wTaichiBuffer,Senkou,i);
         double FlatSE  = iATR(NULL,0,20,i)/Point/2.0;
         
            FlatBuffer[i] = EMPTY_VALUE;
            SignalDn[i]   = EMPTY_VALUE;
            SignalUp[i]   = EMPTY_VALUE;
            TaichiDn[i]   = EMPTY_VALUE;
            TaichiUp[i]   = EMPTY_VALUE;

         if (MathAbs(((wTaichiBuffer[i]-Signal)+(wTaichiBuffer[i]- SSignal)+(Signal-SSignal))/3.0)<FlatSE*Point) FlatBuffer[i]=2;
         if (Signal>SSignal)                             SignalUp[i] = 2;
         if (Signal<SSignal)                             SignalDn[i] = 2;
         if (wTaichiForBuffer[i+Kijun]>wTaichiBuffer[i]) TaichiDn[i] = 1;
         if (wTaichiForBuffer[i+Kijun]<wTaichiBuffer[i]) TaichiUp[i] = 1;
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         FlatBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,0,y);
         SignalDn[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,1,y);
         SignalUp[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,2,y);
         TaichiDn[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,3,y);
         TaichiUp[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,4,y);
   }
   
   //
   //
   //
   //
   //
      
   return(0);
}

//+----------------------------------------------------------------------------------+
//|                                                                                  |
//+----------------------------------------------------------------------------------+
//
//
//
//
//

double iLwma(double& buffer[], int period, int i)
{
   double weight = 0;
   double sum    = 0;
   int    j,k;
   
   if ((Bars-i)>=period)
   {
      for (j=0, k=period; j<period; j++,k--)
      {
            weight += k; sum += buffer[i+j]*k;
      }
      if (weight !=0)
            return(sum/weight);
      else  return(0.0);
    }
    else return(buffer[i]);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}